<?php
$pluginData[upsharg][type] = 'payment';
$pluginData[upsharg][name] = 'پرداخت آنلاین';
$pluginData[upsharg][uniq] = 'upsharg';
$pluginData[upsharg][description] = '';
$pluginData[upsharg][author][name] = 'upsharg';
$pluginData[upsharg][author][url] = 'http://upsharg.pw';
$pluginData[upsharg][author][email] = 'sales@xdev.ir';
$pluginData[upsharg][field][config][1][title] = 'لطفا API_KEY خود را در فیلد زیر وارد نمایید ';
$pluginData[upsharg][field][config][1][name] = 'api_key';

    
function upsharg_pay($api_key, $amount, $redirect){
    $ch = curl_init();
    curl_setopt($ch,CURLOPT_URL,'http://upsharg.pw/invoice/request');
    curl_setopt($ch,CURLOPT_POSTFIELDS,"api_key=$api_key&amount=$amount&return_url=$redirect");
    curl_setopt($ch,CURLOPT_POST,true);
    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);
    curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,false);
    curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
    curl_setopt($ch,CURLOPT_FOLLOWLOCATION,true);
    $res = curl_exec($ch);
    curl_close($ch);
    return $res;
}

function upsharg_verify($api_key, $inv_key){
    $ch = curl_init();
    curl_setopt($ch,CURLOPT_URL,'http://upsharg.pw/invoice/check/'.$inv_key);
    curl_setopt($ch,CURLOPT_POSTFIELDS,"api_key=$api_key");
    curl_setopt($ch,CURLOPT_POST,true);
    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);
    curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,false);
    curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
    curl_setopt($ch,CURLOPT_FOLLOWLOCATION,true);
    $res = curl_exec($ch);
    curl_close($ch);
    return $res;
}

function hasSuccessfulPaymentBefore($email, $mobile){
    global $db;
    $sql = 'SELECT *  FROM `payment` WHERE ( `payment_email` = "'.$email.'" OR ( `payment_mobile` = "'.$mobile.'" AND `payment_mobile` != "") ) AND `payment_status` = 2 LIMIT 1;';
    $payment = $db->fetch($sql);
    if(isset($payment[payment_id])){
        return true;
    }
    return false;
}


function isMobileDevice(){
    $useragent=$_SERVER['HTTP_USER_AGENT'];
    if(preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i',$useragent)||preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i',substr($useragent,0,4)))
        return true;
    return false;
}

function gateway__upsharg($data)
{
    global $config,$smarty,$db;
    
    $sql = 'SELECT * FROM `payment` WHERE `payment_rand` = "'.$data[invoice_id].'" LIMIT 1;';
    $payment = $db->fetch($sql);
    
    $api = $data[api_key];
    $amount = $data[amount];
    $factorNumber = $data[invoice_id];
    $redirect = $data[callback].'&payid='.$payment['payment_id'];
    $result = upsharg_pay($api,$amount,$redirect);
    $result = json_decode($result,1);

    if(!hasSuccessfulPaymentBefore($payment['payment_email'], $payment['payment_mobile'])){
                // Limit pc devices
                $data[title] = 'خطای سیستم';
                $data[message] = '<font color="red" style="font-size:20px;">پرداخت آنلاین موقتا غیر فعال است. برای خرید اکانت لطفا از طریق ایمیل با پشتیبانی در ارتباط باشید.</font><br />'. '<a href="index.php" class="button">بازگشت</a>';
                $smarty->assign('data', $data);
                $smarty->display('message.tpl');
                exit;
    }

    if($result['status'] == 1) {
        $update[payment_rand] = $result['invoice_key'];
        $sql = $db->queryUpdate('payment', $update, 'WHERE `payment_rand` = "'.$factorNumber.'" LIMIT 1;');
        $db->execute($sql);
        $go = "http://upsharg.pw/invoice/pay/".$result['invoice_key'];
        header("Location: $go");
        exit;
    } else {
        //-- نمایش خطا
        $data[title] = 'خطای سیستم';
        $data[message] = '<font color="red">در ارتباط با درگاه مشکلی به وجود آمده است.</font> شماره خطا: '.$result['errorCode'].'<br />'.'متن خطا: '.$result['errorDescription'].'<br />'. '<a href="index.php" class="button">بازگشت</a>';
        $smarty->assign('data', $data);
        $smarty->display('message.tpl');
        exit;
    }
}

function callback__upsharg($data)
{
    global $db,$post,$smarty;
    $api = $data[api_key];
    
    $sql = 'SELECT * FROM `payment` WHERE `payment_rand` = "'.$post['invoice_key'].'" LIMIT 1;';
    $payment = $db->fetch($sql);
    if($payment) {
        if ($payment[payment_status] == 1) { // amadeye pardakht bude
            $result = upsharg_verify($api, $payment['payment_rand']);
            $result = json_decode($result,1);
            if($result['status'] == 1) {
                $output[status] = 1;
                $output[res_num] = NULL;
                $output[ref_num] = $result['bank_code'];
                $output[payment_id] = $payment[payment_id];
            } else {
                $output[status] = 0;
                $output[message] = 'تراکنش موفقیت آمیز نبود.';
            }
        } else {
            $output[status] = 0;
            $output[message] = 'چنین سفارشی تعریف نشده است.';
        }
    } else {
        $output[status]    = 0;
        $output[message]= 'اطلاعات پرداخت کامل نیست.';
    }
    return $output;
}

